#pragma config(Sensor, S1,     COLOUR,         sensorCOLORFULL)
#pragma config(Sensor, S2,     TOUCH,          sensorTouch)
#pragma config(Motor,  motorA,          MOTOR_A,       tmotorNXT, PIDControl, encoder)
//*!!Code automatically generated by 'ROBOTC' configuration wizard               !!*//

/**
 * ptr tutorial example 4
 *
 * License: You may use this code as you wish, provided you give credit where it's due.
 *
 * Xander Soldaat
 * 12 March 2013
 * version 0.1
 */

// Change this to however many data points you wish to log
#define MAX_DATAPOINTS 50

struct
{
  TColors colourNum;
  bool touchSensorPressed;
  long motorEncoder;
  long timeStamp;
} tDataEntry;

// Array of tDataEntry structs to hold our sensor and motor data
tDataEntry dataEntries[MAX_DATAPOINTS];

void readData(tDataEntry *data)
{
  data->colourNum = (TColors)SensorValue[COLOUR];
  data->touchSensorPressed = (bool)SensorBoolean[TOUCH];
  data->motorEncoder = nMotorEncoder[MOTOR_A];
  data->timeStamp = nPgmTime;
}

void printData(int index, tDataEntry *data)
{
  char *touchStatus;

  // Change the boolean value into touch sensor status
  touchStatus = (data->touchSensorPressed) ? "pressed" : "released";

  // Display the values
  eraseDisplay();
  nxtDisplayCenteredTextLine(0, "Data Entries");
  nxtDisplayTextLine(1, "-------------------");
  nxtDisplayTextLine(2, "Time: %d",   data->timeStamp);
  nxtDisplayTextLine(3, "Colour: %d", data->colourNum);
  nxtDisplayTextLine(4, "Touch: %s",  touchStatus);
  nxtDisplayTextLine(5, "Motor: %d",  data->motorEncoder);
  nxtDisplayTextLine(6, "-------------------");
  nxtDisplayTextLine(7, "<<     %2d      >>", index);
}

task main()
{
  int index = 0;
  bool updateScreen = true;

  // Pointer to tDataEntry struct
  tDataEntry *dataPtr;

  eraseDisplay();

  // Start the motor
  motor[MOTOR_A] = 10;

  nxtDisplayCenteredTextLine(3, "Logging data");
  nxtDisplayCenteredTextLine(4, "Please wait...");
  for (index = 0; index < MAX_DATAPOINTS; index++)
  {
    // Point dataPtr to a fresh new data entry struct
    dataPtr = &dataEntries[index];

    // Get the data from the sensors and motor
    readData(dataPtr);

    // Wait a little bit
    wait1Msec(100);
  }
  // Stop the motor again
  motor[MOTOR_A] = 0;

  PlaySound(soundFastUpwardTones);

  // Reset the index
  index = 0;

  while (true)
  {
    switch (nNxtButtonPressed)
    {
      case kLeftButton:  index--;
                         updateScreen = true;
                         break;

      case kRightButton: index++;
                         updateScreen = true;
                         break;
    }

    // The user has pressed a button, so we need to fetch the
    // new data entry and update the screen
    if (updateScreen)
    {
      // Make sure we stay within the bounds of the array
      index = (index > (MAX_DATAPOINTS - 1)) ? MAX_DATAPOINTS - 1 : index;
      index = (index < 0) ? 0 : index;

      // Point dataPtr to the new data entry
      dataPtr = &dataEntries[index];

      // Print out the new data entry
      printData(index, dataPtr);

      // Make sure we don't update the screen again
      updateScreen = false;

      // wait for button to not be pressed anymore
      while(nNxtButtonPressed != kNoButton)
        wait1Msec(10);
    }
    wait1Msec(50);
  }
}
